Pull request:    

Description

I have a use case where we have a 21-bit block of IP addresses (4,096) that we cannot further subnet.  The router is maintained by

another organization, and we already have hundreds of devices using this network, mostly statically assigned.  We currently block off

ranges in a spreadsheet for each customer, and they maintain their own IP Addresses.

We now want to implement a Foreman server to manage the IP addressing, and would like to limit the range of available IPs for each

customer.

I would like to propose the creation of a new tab in the "Subnets" edit interface called "IP Ranges".  In this tab, you start with a "+Add

IP Range" button.  When the button is clicked, a modal/dialog pops up where you enter the following information:

- Start of IP Range

- End of IP Range

- assign Locations

- assign Organizations

- ??? other relevant info?

You will be able to create one or more IP Ranges that can be assigned to different organizations, and the "Suggested IP" upon

interface assignment will come from the organization's assigned "IP Ranges".

Look and Feel:  I particularly like the way the Interfaces sub-interface looks like.

Proposed mock-up:

 jHtSIoq.png 

Related issues:

Related to Foreman - Feature #11250: Remove uniqueness check from network add... Closed 07/29/2015

Related to Foreman - Feature #10169: Subnets: Option to exclude IP range New 04/17/2015

Has duplicate Foreman - Feature #14627: ability to use multiple ranges in a s... Duplicate 04/13/2016

History

#1 - 06/29/2015 05:08 PM - larry campbell

discussion thread:

https://groups.google.com/forum/?fromgroups=#!searchin/foreman-users/organizations/foreman-users/X-5ensa4Qvc/IgL9C-8YHhcJ

#2 - 06/30/2015 03:02 AM - Marek Hulán

- Category set to Network

Sorry I missed the original discussion and thanks for the link. I like the idea but it seems as quite big change, wouldn't it be easier to allow subnets

with the same network address so you could use multiple subnets as you originally suggested? I'm not sure why we insist on this value being unique.

#3 - 06/30/2015 08:53 AM - larry campbell

Allowing multiple subnets with the same network address would certainly serve the need... This feature request is the culmination of all the "needs"

and "nice to haves" that people in my org came up with.  I guess at this point, we need to know the costs of developing this, and if it even makes

sense the way subnets and Foreman work.
Question:

The simple request of "allow multiple subnets with the same network address" is something we need faster than all the other features in the request. 

Should I open a separate issue for that less complex request, and leave this one to be possibly picked up at a later date if it makes sense to

implement?

Marek Hulán wrote:

Sorry I missed the original discussion and thanks for the link. I like the idea but it seems as quite big change, wouldn't it be easier to allow

subnets with the same network address so you could use multiple subnets as you originally suggested? I'm not sure why we insist on this value

being unique.

#4 - 06/30/2015 08:59 AM - Marek Hulán

That would make sense to me (even though some might find a good reason why we don't allow this today)

#5 - 07/01/2015 06:08 AM - Lukas Zapletal

Hmmm what makes you think that this is a big change, Marek? I like the idea. The only issue I see is Remaining IP column, that information you need

to fetch from proxy. I'd suggest not to display it by default, maybe a hoover or link over Total IP could display that.

Larry the best think you can do is to try implement that. We will help you with coding and review the POC. Even if your POC is not success, we can

maybe take from there and finish if it looks good enough.

#6 - 07/01/2015 07:12 AM - Marek Hulán

Lukas I think that orchestration code will be affected and I'm not sure how we'll be able to pick the right range from DHCP server (note that you could

specify range out of subnet if I understood the feature correctly). Also validations preventing overlaps can be a bit challenging. So a quick fix that we

can do is just disabling the validation. If Larry is willing to work on "full" feature, that's great and I'll try to support as much as possible.

#7 - 07/01/2015 12:17 PM - larry campbell

alright, i'm willing to give it a go... I have 0 experience in Rails development or producing anything for foreman with this regard.  Can you link me to

the most appropriate starting place for this integration?  Thanks.

#8 - 07/02/2015 04:38 AM - Marek Hulán

I think this could help http://theforeman.org/contribute.html, also you can ask questions on our #theforeman-dev IRC channel. Most devs are in

Europe timezone but reponses are usually quick.

#9 - 07/29/2015 01:41 PM - larry campbell

I have opened a competing issue #11250 to provide a simple alternative to this feature request.

#10 - 08/06/2015 03:33 AM - Dominic Cleal

- Related to Feature #11250: Remove uniqueness check from network address validator in subnet.rb added

#11 - 04/14/2016 03:10 AM - Dominic Cleal

- Has duplicate Feature #14627: ability to use multiple ranges in a subnet added

#12 - 10/03/2016 07:04 AM - Marek Hulán

- Related to Feature #10169: Subnets: Option to exclude IP range added
